<?php
/*
 * Plugin Name: Password Blacklist
 * Plugin URI: 
 * Version: 0.6
 * Description: When a user updates their password check it against a blacklist of passwords
 * Author: Ben Lobaugh
 * Author URI: http://ben.lobaugh.net
 */

define( 'BPB_TABLE', 'invalid_passwords' );

class blobaugh_Password_Blacklist {

	public function hooks() {
		add_action( 'user_profile_update_errors', array( $this, 'validate_user_profile_update' ), 0, 3 );
	}

	public function validate_user_profile_update( $errors, $update, $user_data ) {
		return $this->validate_password( $errors, $user_data );
	}

	public function validate_password( $errors, $user_data ) {
		global $wpdb;
		/*echo '<pre>';
		var_dump( $errors );
		var_dump( $user_data );
		var_dump( $_POST );
		*/

		$password = ( isset( $_POST[ 'pass1' ] ) && trim( $_POST[ 'pass1' ] ) ) ? $_POST[ 'pass1' ] : false;

		/*
		 * If there is not a password set or a password error already exists then
		 * we do not need to continue doing our check.
		 */
		if ( ( false === $password ) || ( $errors->get_error_data("pass") ) ) {
			return $errors;
		}

		$query = $wpdb->prepare(
				"SELECT COUNT(password)
				 FROM " . BPB_TABLE . "
				 WHERE `password` = '%s'",
				 $password
		);
		
		$password = $wpdb->get_var( $query );
		
		if( $password > 0 ) {
			$errors->add( 'pass', __( 'Please chose a different password that is not on the blacklist.', 'bpb' ) );
		}
	}
} // end class 

$bpb = new blobaugh_Password_Blacklist();
$bpb->hooks();
